#
# $Header: /home/scott/lib/cvsroot/Gtk2-Deprecated/Makefile.PL,v 1.5 2004/04/02 18:17:18 scott Exp $
#

use 5.008;
use ExtUtils::MakeMaker;
use File::Spec;
use Config;
use Cwd;

our %reqs = (
	'ExtUtils::Depends' => 0.2, # required anyway by Glib 1.040
	'Glib' => 1.040, # we need the new docgen and makehelper stuff.
	'Gtk2' => 1.0,
);

# Writing a fake Makefile ensures that CPAN will pick up the correct
# dependencies and install them.
unless (eval "use ExtUtils::Depends '$reqs{'ExtUtils::Depends'}';"
           # just seeing if Glib is available isn't enough, make sure
           # it's recent enough, too 
           . "use Glib '$reqs{'Glib'}';"
	   . "use Glib::MakeHelper;"
           . "use Gtk2 '$reqs{'Gtk2'}';"
           . "use Gtk2::CodeGen;"
           . "1") {
   warn "$@\n";
   WriteMakefile(
         NAME => 'Gtk2::Deprecated',
         PREREQ_FATAL => 1,
         PREREQ_PM    => \%req,
   );
   exit 1; # not reached
}

mkdir 'build', 0777;

#
# autogeneration
#
Gtk2::CodeGen->parse_maps ('gtk2perl_deprecated');
Gtk2::CodeGen->write_boot (ignore => 'Deprecated');

our @xs_files = <xs/*.xs>;
our %pm_files = (
	'Deprecated.pm' => '$(INST_LIBDIR)/Deprecated.pm',
);
our %pod_files = (
	'Deprecated.pm' => '$(INST_MAN3DIR)/Gtk2::Deprecated.$(MAN3EXT)',
	Glib::MakeHelper->do_pod_files (@xs_files),
);


our $gtk2dep = ExtUtils::Depends->new ('Gtk2::Deprecated', 'Gtk2');
$gtk2dep->set_libs (find_extra_libs());
$gtk2dep->add_pm (%pm_files);
$gtk2dep->add_xs (<xs/*.xs>);
my $cwd = cwd();
$gtk2dep->add_typemaps (map {File::Spec->catfile($cwd,$_)}
		     'build/gtk2perl_deprecated.typemap',
		     'deprecated.typemap',
		     );

$gtk2dep->install (qw(gtk2perl_deprecated.h build/gtk2perl_deprecated-autogen.h));
$gtk2dep->save_config ('build/IFiles.pm');

WriteMakefile(
    NAME          => 'Gtk2::Deprecated',
    VERSION_FROM  => 'Deprecated.pm', # finds $VERSION
    ABSTRACT_FROM => 'Deprecated.pm', # retrieve abstract from module
    XSPROTOARG    => '-noprototypes',
    MAN3PODS      => \%pod_files,
    $gtk2dep->get_makefile_vars,
);

sub MY::postamble {
	return Glib::MakeHelper->postamble_clean
	     . Glib::MakeHelper->postamble_docs_full (
			DEPENDS => $gtk2dep,
			COPYRIGHT => 'Copyright (C) 2003-2004 by muppet.  Large portions of this code come directly from Gtk-Perl, which was written by Kenneth Albanowski, Paolo Maloro, and others.',
	       )
	     . Glib::MakeHelper->postamble_rpms (
	       );
}

# this probably needs to go into ExtUtils::Depends.
sub find_extra_libs {
	# right now we need this terrible hack only for windows.
	return "" unless $^O eq "MSWin32";

	# win32 does not allow unresolved symbols in libraries, but
	# Gtk2 depends on symbols in the dll created for Glib.
	# so, we have to break all this nice abstraction and encapsulation
	# and find the actual Glib.dll and Glib.lib installed by perl when
	# the Glib module was built, and add it to the list of lib files.
	#
	# say it with me: "i hate win32."

	my $retstring = "";

	use File::Find;
	find (sub {
			$retstring .= " ".$File::Find::name
				if /(Glib|Gtk2).lib/i;
		}, @INC);

	return $retstring;
}
